/*
 "@(#) ID: pack.h  V 1.5, 9/16/94 at 12:48:09 mbyrne@accurate.com";
*/

#define MSGNAME		"mime.msg"	/* default MIME message file 	*/
#define BOUNDARY 	"unique-boundary"
#define CONFIGFILE 	".sgmls_profile"
#define DESCRIPTOR 	""		/* null descriptor default	*/

#define APPL_SGML	"Application/SGML"

#define FNAMELEN	100
#define MAXFNAMES	100
#define MAXEXTIDS	MAXFNAMES	/* max external ids	*/
#define MAXCTYPES	100		/* max Content-Types	*/

#define PACK 11
#define UNPACK 12
#define SGMLS 13

#define SUCCESS 6
#define FAILURE 7

struct ENTITYLIST {
	char oldname[FNAMELEN];
	char newname[FNAMELEN];
	char extid[FNAMELEN];		/* ties to notalist.extid */
	char tempfile[FNAMELEN];
	char alreadyout;
	int  docnum;
	int  inode;
};

struct NOTATLIST {
	char extid[FNAMELEN];		/* ties to entitylist.extid */
	char mimeid[FNAMELEN];		/* ties to contentype.extype */
};

/* The following table translates the external id 
   to Content Type needed for the MIME body part
   The table is initialized by reading the configuration file into
   memory, looking for "smgls-" entries and storing pointers to each one.
   */
struct CONTENTYPE {
	char *extype;		/* ties to motatlist.mimeid	*/
	char *mimetype;		/* goes into MIME msg as Content-ID */
};

/* The following table holds the input info for the unpacker.	*/
struct IDLIST {
	char filename[FNAMELEN];
	char contentid[FNAMELEN];
	char tempfile[FNAMELEN];  /* for output, mv to filename at end */
	int pid;		/* associate doc with pid	*/
};

struct NEST {
	FILE *fp;
	char tempfile[FNAMELEN];
};


/* From sgmlio.c						*/
struct iofcb {                /* I/O file control block. */
     FILE *fp;		      /* File handle. */
     fpos_t off;              /* Offset in file of current read block. */
     char *next;              /* Next file (NULL if no more). */
     char *file;              /* Current file (no length byte). */
     int pendoff;	      /* Offset into line when file suspended. */
     char bol;	              /* Non-zero if currently at beginning of line. */
     char first;	      /* Non-zero if the first read.  */
     char wasbol;	      /* Non-zero if current block was at beginning of line. */
     char canseek;
     UNCH *pendbuf;	      /* Saved partial buffer for suspended file
				 that can't be closed and reopened. */
};
